<?php

defined('ABSPATH') or die("No script kiddies please!");



/*-----------------------------------------------------------------------------------*/
/*	Licence management section
/*-----------------------------------------------------------------------------------*/

if ( ! function_exists( 'ag_plugin_licence' ) ) {

	add_action('admin_menu', 'ag_plugin_licence');
	function ag_plugin_licence() {
	  add_menu_page('AG License Activation Menu', 'AG Plugins', 'manage_options', 'AG_licence', 'AG_plugins_page', 'dashicons-admin-network');
		//plugins_url( 'AG-Woo-SagePay-Server/img/weareag.svg' )
	}

}


if ( ! function_exists( 'AG_plugins_page' ) ) {

	function AG_plugins_page() {
	    echo '<div class="wrap">';
	    echo '<h2>We are AG Plugin License Management</h2>';
			echo '<p>Please enter the license key for this product to activate it. You were given a license key when you purchased this item.</p>';

			do_action( 'load_ag_plugins' );

			echo '<p>When moving plugin from one site to another (from development server to live site) you <strong>MUST</strong> deactivate your plugin first on development before you move it over.</p>';
	    echo '</div>';
	}

}

/*-----------------------------------------------------------------------------------*/
/*	End
/*-----------------------------------------------------------------------------------*/


add_action( 'load_ag_plugins', 'epdq_licence_setting' );
function epdq_licence_setting() {

	/*** License activate button was clicked ***/
	if (isset($_REQUEST['PS_ePDQ_key_activate_license'])) {
		$license_key = $_REQUEST['PS_ePDQ_key'];

		// API query parameters
		$api_params = array(
			'slm_action' => 'slm_activate',
			'secret_key' => AGD_KEY,
			'license_key' => $license_key,
			'registered_domain' => $_SERVER['SERVER_NAME'],
			'item_reference' => urlencode(ITEM),
			'product_id' => '1283, 2132, 2133, 2134',
		);

		// Send query to the license manager server
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));

		//echo '<pre>';
		//var_dump($response);//uncomment it if you want to look at the full response
		//echo '</pre>';
		// License data.
		$license_data = json_decode(wp_remote_retrieve_body($response));

		// TODO - Do something with it.
		//var_dump($license_data);//uncomment it to look at the data

		if($license_data->result == 'success'){//Success was returned for the license activation
				update_option('PS_ePDQ_key', $license_key);
				update_option('PS_ePDQ_key_message', $license_data->message);
				add_option('PS_ePDQ_key_message', $license_data->message);
				$fulldate = $response['headers']['expires'];
				$words = explode(" ", $fulldate);
				$date = join(" ", array_slice($words, 0, 4));
				add_option('PS_ePDQ_key_expires', $date);
				update_option('PS_ePDQ_key_expires', $date);
		} else {
			update_option('PS_ePDQ_key_message', $license_data->message);
		}

	}
	/*** End of license activation ***/

	/*** License activate button was clicked ***/
	if (isset($_REQUEST['PS_ePDQ_key_deactivate_license'])) {
		$license_key = $_REQUEST['PS_ePDQ_key'];

		// API query parameters
		$api_params = array(
			'slm_action' => 'slm_deactivate',
			'secret_key' => AGD_KEY,
			'license_key' => $license_key,
			'registered_domain' => $_SERVER['SERVER_NAME'],
			'item_reference' => urlencode(ITEM),
			'product_id' => '1283, 2132, 2133, 2134',
		);

		// Send query to the license manager server
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));
		$license_data = json_decode(wp_remote_retrieve_body($response));
		if($license_data->result == 'success'){//Success was returned for the license activation
				//Remove the licensse key from the options table. It will need to be activated again.
				update_option('PS_ePDQ_key', '');
				update_option('PS_ePDQ_key_message', $license_data->message);
				echo $response->headers->expires;
		} else {
			update_option('PS_ePDQ_key_message', $license_data->message);
		}

	}

?>
<form action="" method="post" style="padding-top: 20px; padding-bottom: 20px;">
	<table class="form-table">
		<tr><br  />
      <label class="licence_label" for="PS_ePDQ_key"><strong>ePDQ Licence Key</strong></label>
      <th style="width:10px;  padding-bottom: 0;"><input class="regular-text" type="password" id="PS_ePDQ_key" name="PS_ePDQ_key"  value="<?php echo get_option('PS_ePDQ_key'); ?>" ><input type="submit" name="PS_ePDQ_key_activate_license" value="Activate" class="button-primary activate_license" /><input type="submit" name="PS_ePDQ_key_deactivate_license" value="Deactivate" class="button" />
        <?php echo '<p style="color: green"><strong>Licence Active</strong></p>'; ?></th>
  <br  /></tr>
	</table>
	<p style="margin-top: 0; ">Need some help setting up this plugin? <a href="<?php echo site_url(); ?>/wp-admin/index.php?page=welcome-screen-about">Click here</a></p>
</form>
<hr />

<?php

}



function example_options_page_enqueue_assets() {
	wp_enqueue_script('common');
	wp_enqueue_script('jquery-color');
	wp_print_scripts('editor');
	if (function_exists('add_thickbox')) add_thickbox();
	wp_print_scripts('media-upload');
	if (function_exists('wp_tiny_mce')) wp_tiny_mce();
	wp_admin_css();
	wp_enqueue_script('utils');
	do_action("admin_print_styles-post-php");
	do_action('admin_print_styles');

}



class WC_Nom_EPDQ extends WC_Payment_Gateway {



public function __construct() {
		global $woocommerce;

		$this->id 			= 'epdq_checkout';
		$this->method_title = 'AG EPDQ Checkout';//__( '', 'woocommerce' );
		$this->icon 		= plugins_url('AG-woocommerce-epdq-payment-gateway/cards.gif');
		$this->has_fields 	= false;

		// Load the settings.
		$this->init_form_fields();
		$this->init_settings();

		$this->title 		= $this->get_option( 'title' );
		$this->title 		= (isset($this->title) and $this->title !='') ? $this->title : 'EPDQ Checkout';
		$this->description 	= $this->get_option( 'description' );
		$this->access_key 	= $this->get_option( 'access_key' );
		$this->test_url 	= 'https://mdepayments.epdq.co.uk/ncol/test/orderstandard.asp';
		$this->live_url 	= 'https://payments.epdq.co.uk/ncol/prod/orderstandard.asp';
		$this->status 		= $this->get_option('status');
		$this->error_notice = $this->get_option('error_notice');
		$this->sha_in 		= $this->get_option('sha_in');
		$this->sha_out 		= $this->get_option('sha_out');
		$this->sha_method 	= $this->get_option('sha_method');
		$this->debug	 	= $this->get_option('debug');
		$this->showcase	 	= $this->get_option('showcase');
		$this->logo	 		= $this->get_option('logo');
		$this->prefix	 		= $this->get_option('prefix');
		$this->TITLE = $this->get_option('TITLE');
		$this->sha_method 	= ($this->sha_method !='') ? $this->sha_method : 0;

		$this->accept_url 	= $this->get_option('accept_url');
		$this->decline_url 	= $this->get_option('decline_url');
		$this->exception_url= $this->get_option('exception_url');
		$this->notice_url	= $this->get_option('notice_url');

		$this->aavscheck = $this->get_option('aavcheck');
		$this->cvccheck = $this->get_option('cvccheck');



		// Save options
		if ( version_compare( WOOCOMMERCE_VERSION, '2.0.0', '>=' ) )
			add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( &$this, 'process_admin_options' ) );
		else
			add_action( 'woocommerce_update_options_payment_gateways', array( &$this, 'process_admin_options' ) );

		// Payment listener/API hook
		add_action('woocommerce_receipt_epdq_checkout', array(&$this, 'receipt_page'));
		add_action('woocommerce_thankyou_epdq_checkout', array(&$this, 'thank_you'));
		add_action('woocommerce_api_wc_nom_epdq', array(&$this, 'check_epdq_response'));
	}

	public function admin_options() {
		global $woocommerce;
		?>

		<h3><?php _e( 'AG EPDQ Checkout Settings', 'woocommerce' );?></h3>
		<p><?php _e('Barclays EPDQ Payment gateway to accept payments directly into your Barclays account. <br /> This gateway will redirect the customers to the secured Barclay payment receiving page and process order there
						and then send them back to the provided links based on the status of their transection.','woocommerce')?></p>

	<?php
			// If the user said yes to showcase
			// Website information
			$websitename = get_option( 'blogname' );
			$websiteurl = get_option ('siteurl');
			$admin_email = get_option( 'admin_email' );
			$showcasedata = array('Website name:', $websitename, 'Website URL: ', $websiteurl, 'Email: ', $admin_email,);
			$showcase = implode("\n", $showcasedata);

			if ($this->showcase == 'yes') {
				// Send the email to support only once the user has ticked that they are happy.
				$to = 'support@weareag.co.uk';
				$subject = 'Epdq plugin showcase';
				$body = $showcase;
				$headers = array('Content-Type: text/html; charset=UTF-8');
				wp_mail( $to, $subject, $body, $headers );
			}
			add_option( 'weareag_prefix', $this->prefix, '', 'yes' );

			// If the user has allowed us to track then collect the follwing so we have better information for debug

			// Theme data
			$theme_data = wp_get_theme();
			$themename = $theme_data->display( 'Name', false, false );
			$themeURL = $theme_data->display( 'ThemeURI', false, false );
			$themeversion = $theme_data->display( 'Version', false, false );

			// Website information
			$websitename = get_option( 'blogname' );
			$websiteurl = get_option ('siteurl');

			// Add all data to array ready for email
			$emaildata = array('Theme name:', $themename, 'Theme URL', $themeURL, 'Theme Version:', $themeversion, 'Website name:', $websitename, 'Website URL: ', $websiteurl);
			//var_dump($emaildata);
			$emailcleandata = implode("\n", $emaildata);

			if ($this->debug == 'yes') {
				// Send the email to support only once the user has ticked that they are happy.
				$to = 'support@weareag.co.uk';
				$subject = 'Epdq debug email';
				$body = $emailcleandata;
				$headers = array('Content-Type: text/html; charset=UTF-8');
				wp_mail( $to, $subject, $body, $headers );
			}

		$license = get_option('PS_ePDQ_key');
		$api_params = array(
			'slm_action' => 'slm_check',
			'secret_key' => AGD_KEY,
			'license_key' => $license,
		);
		$query = esc_url_raw(add_query_arg($api_params, AGD));
		$response = wp_remote_get($query, array('timeout' => 20, 'sslverify' => false));
		//echo '<pre>';
		//var_dump($response);//uncomment it if you want to look at the full response
		//echo '</pre>';
		$license_data = json_decode(wp_remote_retrieve_body($response));
		echo '<strong>';
		echo $license_data->message;
		echo '</strong>';
		//if($license_data->result == 'success'){
			echo '<br />Thank You Purchasing!'; ?>
			<table class="form-table">
				<?php $this->generate_settings_html(); ?>
			</table> <!--/.form-table-->

<p>Need some help setting up this plugin? <a href="<?php echo site_url(); ?>/wp-admin/index.php?page=welcome-screen-about">Click here</a></p>



		<?php

	  }

	public function init_form_fields() {
		$this->form_fields = array(
				'enabled' => array(
						'title' => __( 'Enable/Disable', 'woocommerce' ),
						'type' => 'checkbox',
						'label' => __( 'Enable EPDQ Checkout', 'woocommerce' ),
						'default' => 'no'
				),

				'logo' => array(
					'title' => __( 'Logo for payment page', 'woocommerce' ),
					'type' => 'text',
					'label' => __( 'Upload image for payment page', 'woocommerce' ),
					'default' => '',
					'description'=>'Add an image to display on the payment page - paste in the full image url <strong>You must have an SSL for this to work correctly.</strong>',
					'desc_tip'=>false
				),
				//'TITLE'=> array(
				//	'title' => __( 'Payment page title', 'woocommerce' ),
				//	'type' => 'text',
				//	'description' => __( 'Title of the payment page. This will be shown under the logo on the payment page', 'woocommerce' ),
				//	'default' => '',
				//	'desc_tip'      => false
				//),
				'title' => array(
						'title' => __( 'Title', 'woocommerce' ),
						'type' => 'text',
						'description' => __( 'Title of the payment process. This name will be visible throughout the site and the payment page.', 'woocommerce' ),
						'default' => 'EPDQ Checkout',
						'desc_tip'      => true
				),
				'description' => array(
						'title' => __( 'Description', 'woocommerce' ),
						'type' => 'textarea',
						'description' => __( 'Description of the payment process. This description will be visible throuhout the site and the payment page.', 'woocommerce' ),
						'default' => 'Use the payment processor of barclay bank and checkout with your debit/credit card.',
						'desc_tip'      => true
				),
				'access_key' => array(
						'title' => __( 'PSPID', 'woocommerce' ),
						'type' => 'text',
						'description' => __( 'The PSPID for your barclays account. This is the id which you use to login the admin panel of the barclays bank.', 'woocommerce' ),
						'default' => '',
						'desc_tip'      => true
				),
				'status' => array(
						'title' => __( 'Store Status', 'woocommerce' ),
						'type' => 'select',
						'options'=> array('test'=>'Test Environment','live'=>'Live Store'),
						'description' => __( 'The status of your store tells that are you actually ready to run your shop or its still a test environment. If the test is selected then no payments will be processed. For details please refer to the user guide provided by the Barclays EPDQ servise.', 'woocommerce' ),
						'default' => '',
						'desc_tip'      => true,
				),
				'sha_in' => array(
						'title' => __( 'SHA-IN Passphrase', 'woocommerce' ),
						'type' => 'text',
						'description' => __( 'The SHA-IN signature will encode the parameter passed to the payment processor via the hidden fields to ensure better security.', 'woocommerce' ),
						'default' => '',
						'desc_tip'      => true
				),
				'sha_out' => array(
						'title' => __( 'SHA-OUT Passphrase', 'woocommerce' ),
						'type' => 'text',
						'description' => __( 'The SHA-OUT signature will encode the parameter passed to the redirection url from the payment processor to ensure better security.', 'woocommerce' ),
						'default' => 0,
						'desc_tip'      => true
				),
				'sha_method' => array(
						'title' => __( 'SHA encription method', 'woocommerce' ),
						'type' => 'select',
						'options'=> array(0=>'SHA-1',1=>'SHA-256',2=>'SHA-512'),
						'description' => __( 'Sha encryption method - this needs to be similar waht you have set in the epdq backoffice.', 'woocommerce' ),
						'default' => '',
						'desc_tip'      => true,
				),
				'debug' => array(
						'title' => __( 'Allow anonymous tracking.', 'woocommerce' ),
						'type' => 'checkbox',
						'label' => __( 'Enable plugin debug,', 'woocommerce' ),
						'default' => '',
						'description'=>'Please allow our plugin to track anonymous data, so that we can strongly improve our plugin and your user experience. This will *not* slow down your website or allow us access to your website. ',
						'desc_tip'=>true
					),
				'showcase' => array(
					'title' => __( 'Submit your website to our showcase', 'woocommerce' ),
					'type' => 'checkbox',
					'label' => __( 'Submit your website for our up and coming showcase, We will take a screenshot of your website and add a link to your website. We will send you an email to say when it has been added.', 'woocommerce' ),
					'default' => '',
					//'description'=>'Submit your website for our up and coming showcase, We will take a screenshot of your website and add a link to your website.',
					'desc_tip'=>true
				),
				'prefix' => array(
					'title' => __( 'Add a prefix to your order numbers', 'woocommerce' ),
					'type' => 'text',
					'label' => __( 'Add a prefix to your order numbers', 'woocommerce' ),
					'default' => '',
					'desc_tip'=>true
				),


		);

	}



	function process_payment($order_id){
		global $woocommerce;
		$order = new WC_Order( $order_id );
		return array('result' => 'success', 'redirect' => add_query_arg(array('key' => $order->order_key), $order->get_checkout_payment_url( $on_checkout = true )));
	}

	function receipt_page($order_id){
		global $woocommerce;
		$order = new WC_Order( $order_id );

		$this->notify_url = str_replace( 'https:', 'http:', add_query_arg( 'wc-api', 'WC_Nom_EPDQ', $order->get_checkout_order_received_url() ) );
		$fields = array(
				'PSPID'=>$this->access_key,
				'ORDERID'=>$this->prefix . $order->id,
				'AMOUNT'=>$order->order_total*100,
				'CURRENCY'=>get_woocommerce_currency(),
				'LANGUAGE'=>get_bloginfo('language'),
				'CN'=>$order->billing_first_name . ' ' . $order->billing_last_name,
				'EMAIL'=>$order->billing_email,
				'OWNERZIP'=>$order->billing_postcode,
				'OWNERADDRESS'=>$order->billing_address_1,
				'OWNERADDRESS2'=>$order->billing_address_2,
				'OWNERCTY'=>$woocommerce->countries->countries[$order->billing_country],
				'OWNERTOWN'=>$order->billing_city,
				'OWNERTELNO'=>$order->billing_phone,
				'ACCEPTURL'=>$order->get_checkout_order_received_url(),
				'DECLINEURL'=>$order_received_url,
				'EXCEPTIONURL'=>$order_received_url,
				'CANCELURL'=>$order_received_url,
				'LOGO'=>$this->logo,
				'TITLE'=> ''
		);


		$shasign ='';
		$shasign_arg = array();
		ksort($fields);
		foreach($fields as $key => $value){
			if($value=='') continue;
			$shasign_arg[] =  $key .'='. $value;
		}

		if( $this->sha_method == 0 )
			$shasign = sha1(implode($this->sha_in, $shasign_arg).$this->sha_in);
		elseif ( $this->sha_method == 1 )
			$shasign = hash('sha256',implode($this->sha_in, $shasign_arg).$this->sha_in);
		elseif ( $this->sha_method == 2 )
			$shasign = hash('sha512',implode($this->sha_in, $shasign_arg).$this->sha_in);
		else{}


		$epdq_args = array();
		foreach($fields as $key => $value){
			if($value=='') continue;
			$epdq_args[] = "<input type='hidden' name='$key' value='$value'/>";
		}

		if( isset($this->status) and ($this->status=='test' or $this->status =='live') ):
			if($this->status=='test')	$url = $this->test_url;
			if($this->status=='live')	$url = $this->live_url;

			echo '<p>'.__('Thank you for your order, please click the button below to pay securely.', 'woocommerce').'</p>';
			echo '<form action="'.$url.'" method="post" id="epdq_payment_form">';
			echo implode('', $epdq_args);
			echo '<input type="hidden" name="SHASIGN" value="'.$shasign.'"/>';
			echo '<input type="submit" class="button alt" id="submit_epdq_payment_form" value="'.__('Pay securely', 'woocommerce').'" />';
			echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
			echo '<a class="button cancel" href="'.$order->get_cancel_order_url().'">'.__('Cancel order &amp; restore cart', 'woocommerce').'</a></form>';
		else:
			echo '<p class="error">'.$this->error_notice.'</p>';
		endif;

		wc_enqueue_js('
			jQuery("body").block({
					message: "'.__('You are now redirecting to Barclays server to make payment securly.', 'ag-epdq').'",
					overlayCSS:
					{
						background: "#fff",
						opacity: 0.6
					},
					css: {
								padding:        20,
								textAlign:      "center",
								color:          "#555",
								border:         "3px solid #aaa",
								backgroundColor:"#fff",
								cursor:         "wait",
								lineHeight:		"32px"
						}
				});
			jQuery("#submit_epdq_payment_form").click();
		');
	}

	function payment_fields() {
		if ( $description = $this->get_description() )
			echo wpautop( wptexturize( $description ) );
	}

	function thank_you(){
		if( isset($_REQUEST['statusCode']) and isset($_REQUEST['ncerror']) ){
			echo '<div class="errorDetails">';
			echo '<h4 class="errorTitle">Error details</h4>';
			echo '<p><strong>Status code</strong>:&nbsp;<em>'.$_REQUEST['statusCode'].'</em> - '. $this->get_epdq_status_code($_REQUEST['statusCode']).'</p>';
			echo '<p><strong>NCERROR</strong>:&nbsp;<em>'.$_REQUEST['ncerror'].'</em> - '.$this->get_epdq_ncerror($_REQUEST['ncerror']).'.</p>';
			echo '</div>';
		}
	}

	/**
	 * some helper methods
	 */
	function get_pages($title = false, $indent = true) {
		$wp_pages = get_pages('sort_column=menu_order');
		$page_list = array();
		if ($title) $page_list[] = $title;
		foreach ($wp_pages as $page) {
			$prefix = '';
			// show indented child pages?
			if ($indent) {
				$has_parent = $page->post_parent;
				while($has_parent) {
					$prefix .=  ' --- ';
					$next_page = get_page($has_parent);
					$has_parent = $next_page->post_parent;
				}
			}
			// add to page list array array
			$page_list[$page->ID] = $prefix . $page->post_title;
		}
		return $page_list;
	}


	/**
	 * Generate Text Input HTML.
	 *
	 * @access public
	 * @param mixed $key
	 * @param mixed $data
	 * @since 1.0.0
	 * @return string
	 */
	public function generate_text_html( $key, $data ) {
		global $woocommerce;

		$html = '';

		$data['title']			= isset( $data['title'] ) ? $data['title'] : '';
		$data['disabled']		= empty( $data['disabled'] ) ? false : true;
		$data['class'] 			= isset( $data['class'] ) ? $data['class'] : '';
		$data['css'] 			= isset( $data['css'] ) ? $data['css'] : '';
		$data['placeholder'] 	= isset( $data['placeholder'] ) ? $data['placeholder'] : '';
		$data['type'] 			= isset( $data['type'] ) ? $data['type'] : 'text';
		$data['desc_tip']		= isset( $data['desc_tip'] ) ? $data['desc_tip'] : false;
		$data['description']    = isset( $data['description'] ) ? $data['description'] : '';
		$data['append']    		= isset( $data['append'] ) ? $data['append'] : '';
		$data['default']		= isset( $data['default'] ) ? $data['default'] : '';

		$val = esc_attr($this->get_option( $key ));

		if( isset($val) and $val !='' )
			$dflt = $val;
		else
			$dflt = $data['default'];

		// Description handling
		if ( $data['desc_tip'] === true ) {
			$description = '';
			$tip         = $data['description'];
		} elseif ( ! empty( $data['desc_tip'] ) ) {
			$description = $data['description'];
			$tip         = $data['desc_tip'];
		} elseif ( ! empty( $data['description'] ) ) {
			$description = $data['description'];
			$tip         = '';
		} else {
			$description = $tip = '';
		}

		// Custom attribute handling
		$custom_attributes = array();

		if ( ! empty( $data['custom_attributes'] ) && is_array( $data['custom_attributes'] ) )
			foreach ( $data['custom_attributes'] as $attribute => $attribute_value )
			$custom_attributes[] = esc_attr( $attribute ) . '="' . esc_attr( $attribute_value ) . '"';

		$html .= '<tr valign="top">' . "\n";
		$html .= '<th scope="row" class="titledesc">';
		$html .= '<label for="' . esc_attr( $this->plugin_id . $this->id . '_' . $key ) . '">' . wp_kses_post( $data['title'] ) . '</label>';

		if ( $tip )
			$html .= '<img class="help_tip" data-tip="' . esc_attr( $tip ) . '" src="' . $woocommerce->plugin_url() . '/assets/images/help.png" height="16" width="16" />';

		$html .= '</th>' . "\n";
		$html .= '<td class="forminp">' . "\n";
		$html .= '<fieldset><legend class="screen-reader-text"><span>' . wp_kses_post( $data['title'] ) . '</span></legend>' . "\n";
		$html .= '<input class="input-text regular-input ' . esc_attr( $data['class'] ) . '" type="' . esc_attr( $data['type'] ) . '" name="' . esc_attr( $this->plugin_id . $this->id . '_' . $key ) . '" id="' . esc_attr( $this->plugin_id . $this->id . '_' . $key ) . '" style="' . esc_attr( $data['css'] ) . '" value="' .  $dflt  . '" placeholder="' . esc_attr( $data['placeholder'] ) . '" ' . disabled( $data['disabled'], true, false ) . ' ' . implode( ' ', $custom_attributes ) . ' />';

		if ( $description )
			$html .= ' <p class="description">' . wp_kses_post( $description ) . '</p>' . "\n";
		$html .= $data['append'];
		$html .= '</fieldset>';
		$html .= '</td>' . "\n";
		$html .= '</tr>' . "\n";

		return $html;
	}

}


add_filter( 'woocommerce_order_number', 'weareag_order_prefix', 1, 2 );
function weareag_order_prefix( $oldnumber, $order ) {
$prefix = get_option( 'weareag_prefix' );
return $prefix . $order->id; // change weareag to your prefix
}

add_action( 'woocommerce_thankyou_epdq_checkout', 'epdq_transaction_successfull' );
function epdq_transaction_successfull( $order_id ) {
	global $woocommerce;

	if ( !$order_id )
		return;
	$order = new WC_Order( $order_id );
	//foreach( $order->get_items() as $item_key => $item){
	//$transaction_id = get_post_meta($item_key, '_transaction_id', true);
	$noteT  = '<p>Barclay ePDQ transaction is confirmed.<br>';
	$noteT .= 'ePDQ Payment ID: '.$_REQUEST['PAYID'].'</p>';
	$note .= $noteT;
	$order->add_order_note($note);
	$order->payment_complete();
	//$order->update_status('completed', 'order_note');
	//}
}
